JMAP extension for S/MIME signing and encryption
Alexey Melnikov
Isode Ltd
14 Castle Mews
Hampton
Middlesex
TW12 2NP
UK
Alexey.Melnikov@isode.com
2022
JMAP
S/MIME
This document specifies an extension to JMAP for sending S/MIME signed and S/MIME encrypted messages.

Introduction
[RFC8621] is a JSON based application protocol for synchronising email data between a client and a server.
This document describes an extension to JMAP for sending S/MIME signed and encrypted messages . It allows JMAP server to sign/encrypt messages on user's behalf.

Conventions Used in This Document
The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT", "SHOULD", "SHOULD NOT", "RECOMMENDED", "MAY", and "OPTIONAL" in this document are to be interpreted as described in [RFC2119].

Addition to the capabilities object
The capabilities object is returned as part of the standard JMAP Session object; see the JMAP spec. Servers supporting _this_ specification MUST add a property called "urn:ietf:params:jmap:smime-advanced" to the capabilities object.
The value of this property is an empty object in both the JMAP session _capabilities_ property and an account's _accountCapabilities_ property.

Extension to Email/set for S/MIME signing and/or encryption
[RFC8621] defines Email/set method for creating new email messages. This document defines the following additional request arguments that can be used to create S/MIME signed and/or encrypted messages:
smimeSign: "Boolean" (default: false). If included and has the value "true", this requests the JMAP server to create an S/MIME signed message from the message constructed according to other specified arguments (the "original message"). This is done by encapsulating the original message either inside application/pkcs7-mime [RFC8551] or multipart/signed [RFC1847] container. (smimeSignOpaque argument (see below) controls which of the two mechanisms is used.) The signature's private key/certificate is associated with the email address in the Sender header field, if present; otherwise, it is associated with the email address in the From header field, if present.
If multiple addresses are present in one of these header fields, or there is more than one Sender/From header field, the server SHOULD reject the Email/set as invalid with the "invalidEmail" error code; otherwise, it MUST take the first address in the last Sender/From header field.
If JMAP account is not authorized to sign message as the selected sender (as above), it SHOULD return "signedSenderNotAllowed" error code.
smimeEncrypt: "Boolean" (default: false). If included and has the value "true", this requests the JMAP server to create an S/MIME encrypted message from the constructed message. This is done by encapsulating the message inside application/pkcs7-mime [RFC8551] media type. The message MUST be encrypted to the sender and all To/Cc/Bcc recipients. This extension assumes that there is some kind of per user or organizational addressbook, that can be used to lookup public keys of recipients. If lookup of a particular public key fails, or results in an expired or revoked certificate, the Email/set operation MUST fail with the "validEncryptionKeyNotFound" error code.
headerProtect: "Boolean" (default: true). If has the value "true", this requests the JMAP server to use S/MIME header protection as specified in draft-ietf-lamps-header-protection when at least one of smimeEncrypt/smimeSign is true.
smimeSignOpaque: "Boolean" (default: true). If has the value "true", this requests the JMAP server to use application/pkcs7-mime media type for S/MIME signing, otherwise multipart/signed media type.
If both "smimeSign" and "smimeEncrypt" are set to true, the message is first signed and then the signed version is encrypted (in that order).
(Note that this extension doesn't allow management of private keys/certificates. How private keys are managed or configured for a particular user is out of scope for this document.)

Example 1:

      [[ "Email/set", {
        "accountId": "ue150411c",
        "create": {
          "k192": {
            "mailboxIds": {
              "2ea1ca41b38e": true
            },
            "keywords": {
              "$seen": true,
              "$draft": true
            },
            "from": [{
              "name": "Joe Bloggs",
              "email": "joe@example.com"
            }],
            "subject": "World domination",
            "receivedAt": "2021-07-07T01:03:11Z",
            "sentAt": "2021-07-10T11:03:11+10:00",
            "smimeSign": true,
            "smimeEncrypt": true,
            "bodyStructure": {
              "type": "text/plain",
              "partId": "bd48",
              "header:Content-Language": "en"
            },
            "bodyValues": {
              "bd48": {
                "value": "I have the most brilliant plan.  Let me tell
                  you all about it.",
                "isTruncated": false
              }
            }
          }
        }
      }, "0" ]]

This will result in the following response:

      [[ "Email/set", {
        "accountId": "ue150411c",
        "oldState": "780823",
        "newState": "780839",
        "created": {
          "k192": {
            "id": "Mf40b5f831efa7233b9eb1c7f",
            "blobId": "Gf40b5f831efa7233b9eb1c7f8f97d84eeeee64f7",
            "threadId": "Td957e72e89f516dc",
            "size": 5096
          }
        },
        ...
      }, "0" ]]

IANA Considerations

JMAP capability registration for "smime-advanced"
IANA is requested to register the "smime" JMAP Capability as follows:
Capability Name: "urn:ietf:params:jmap:smime-advanced"
Specification document: this document
Intended use: common
Change Controller: IETF
Security and privacy considerations: this document, Section 6

JMAP Error Codes Registry Updates

signedSenderNotAllowed error code
JMAP Error Code: signedSenderNotAllowed
Intended use: common
Change controller: IETF
Reference: This document, Section 4
Description: JMAP account is not authorized to S/MIME sign message as the specified sender.

validEncryptionKeyNotFound error code
JMAP Error Code: validEncryptionKeyNotFound
Intended use: common
Change controller: IETF
Reference: This document, Section 4
Description: S/MIME encrypted message can't be generated because no valid certificate (non expired and non revoked) can be found for one of recipients.

Security Considerations
This JMAP extension assumes trust between the user and the JMAP server for purposes of signing and encrypting messages on user's behalf.
This JMAP extension also relies on access to user's (or organization's) addressbook which contain up-to-date certificates for recipients.
This JMAP extension doesn't support management of user's private keys and corresponding certificates.

Normative References
[RFC8621]
[RFC2119]
[RFC8551]
[RFC1847]